<?php
namespace Teknisa\CUS\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Cus00800 extends \Zeedhi\Framework\Controller\Report {
    
    protected $novoCodigo;
    protected $procedureConsumoPlanejado;
    protected $consplan;
    protected $servicoPorGrupo;
    protected $qr2Strategy;

    public function __construct(ReportService $reportService, $novoCodigo, $consplan, $servicoPorGrupo, $qr2Strategy, $procedureConsumoPlanejado, $birtStrategy, $listas) {
        $this->novoCodigo                = $novoCodigo;
        $this->consplan                  = $consplan;
        $this->servicoPorGrupo           = $servicoPorGrupo;
        $this->qr2Strategy               = $qr2Strategy;
        $this->procedureConsumoPlanejado = $procedureConsumoPlanejado;
        $this->birtStrategy              = $birtStrategy;
        $this->reportService = $reportService;
        $this->listas = $listas;
    }

    protected $reportMapping = array (
        'CUS00800' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
                array (
                    'NRORG'         => 'P_NRORG',
                    'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                    'CDFILIAL'      => 'P_CDFILIAL',
                    'NRCONSPLAN'    => 'P_NRCONSPLAN',
                    'LISTASERV'     => 'P_CDSERVFILI',
                    'DTINICIAL_F'   => 'P_DTINICIAL',
                    'DTFINAL_F'     => 'P_DTFINAL',
                    'DTINICIAL_I'   => 'P_DTINI_IMP',
                    'DTFINAL_I'     => 'P_DTFIN_IMP',
                    'CDPRODINI'     => 'P_CDPRODINIC',
                    'CDPRODFIN'     => 'P_CDPRODFINA',
                    'ORDENA'        => 'P_ORDENA',
                    'IDDIFERENCA'   => 'P_DIFERENCA',
                    'DIFERPERC'     => 'P_PEDIFERENCA',
                    'CDPICTPROD'    => 'P_CDPICTPROD'
                ),
            ),
        'CUS00801' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
                array (
                    'NRORG'         => 'P_NRORG',
                    'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                    'CDFILIAL'      => 'P_CDFILIAL',
                    'NRCONSPLAN'    => 'P_NRCONSPLAN',
                    'LISTASERV'     => 'P_CDSERVFILI',
                    'DTINICIAL_F'   => 'P_DTINICIAL',
                    'DTFINAL_F'     => 'P_DTFINAL',
                    'DTINICIAL_I'   => 'P_DTINI_IMP',
                    'DTFINAL_I'     => 'P_DTFIN_IMP',
                    'CDPRODINI'     => 'P_CDPRODINIC',
                    'CDPRODFIN'     => 'P_CDPRODFINA',
                    'ORDENA'        => 'P_ORDENA',
                    'IDDIFERENCA'   => 'P_DIFERENCA',
                    'DIFERPERC'     => 'P_PEDIFERENCA',
                    'CDPICTPROD'    => 'P_CDPICTPROD'
                ),
            ),
        'CUS00802' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
                array (
                    'NRORG'         => 'P_NRORG',
                    'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                    'CDFILIAL'      => 'P_CDFILIAL',
                    'LISTASERV'     => 'P_CDSERVFILI',
                    'DTINICIAL_F'   => 'P_DTINICIAL',
                    'DTFINAL_F'     => 'P_DTFINAL',
                    'DTINICIAL_I'   => 'P_DTINI_IMP',
                    'DTFINAL_I'     => 'P_DTFIN_IMP',
                    'CDPRODINI'     => 'P_CDPRODINIC',
                    'CDPRODFIN'     => 'P_CDPRODFINA',
                    'ORDENA'        => 'P_ORDENA',
                    'CDPICTPROD'    => 'P_CDPICTPROD'
                ),
            ),
        'CUS00803' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
                array (
                    'NRORG'         => 'P_NRORG',
                    'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                    'CDFILIAL'      => 'P_CDFILIAL',
                    'LISTASERV'     => 'P_CDSERVFILI',
                    'DTINICIAL_F'   => 'P_DTINICIAL',
                    'DTFINAL_F'     => 'P_DTFINAL',
                    'DTINICIAL_I'   => 'P_DTINI_IMP',
                    'DTFINAL_I'     => 'P_DTFIN_IMP',
                    'CDPRODINI'     => 'P_CDPRODINIC',
                    'CDPRODFIN'     => 'P_CDPRODFINA',
                    'ORDENA'        => 'P_ORDENA',
                    'CDPICTPROD'    => 'P_CDPICTPROD'
                ),
            ),
        'CUS00804' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
                array (
                    'NRORG'         => 'P_NRORG',
                    'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                    'CDFILIAL'      => 'P_CDFILIAL',
                    'LISTASERV'     => 'P_CDSERVFILI',
                    'DTINICIAL_F'   => 'P_DTINICIAL',
                    'DTFINAL_F'     => 'P_DTFINAL',
                    'DTINICIAL_I'   => 'P_DTINI_IMP',
                    'DTFINAL_I'     => 'P_DTFIN_IMP',
                    'CDPRODINI'     => 'P_CDPRODINIC',
                    'CDPRODFIN'     => 'P_CDPRODFINA',
                    'ORDENA'        => 'P_ORDENA',
                    'CDPICTPROD'    => 'P_CDPICTPROD'
                ),
            ),
        'CUS00805' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
                array (
                    'NRORG'         => 'P_NRORG',
                    'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                    'CDFILIAL'      => 'P_CDFILIAL',
                    'LISTASERV'     => 'P_CDSERVFILI',
                    'DTINICIAL_F'   => 'P_DTINICIAL',
                    'DTFINAL_F'     => 'P_DTFINAL',
                    'DTINICIAL_I'   => 'P_DTINI_IMP',
                    'DTFINAL_I'     => 'P_DTFIN_IMP',
                    'CDPRODINI'     => 'P_CDPRODINIC',
                    'CDPRODFIN'     => 'P_CDPRODFINA',
                    'ORDENA'        => 'P_ORDENA',
                    'CDPICTPROD'    => 'P_CDPICTPROD'
                ),
            ),
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();

        $dataFinal   = \DateTime::createFromFormat('d/m/Y', $row['DTFINAL']);
        $dataInicial = \DateTime::createFromFormat('d/m/Y', $row['DTINICIAL']);
        //Data para filtro do relatório
        $row['DTINICIAL_F'] = $dataInicial->format('dmY');
        $row['DTFINAL_F'] = $dataFinal->format('dmY');
        //Data para exibição nos relatórios
        $row['DTINICIAL_I'] = $dataInicial->format('d/m/Y');
        $row['DTFINAL_I'] = $dataFinal->format('d/m/Y');
        
        if(!$row['NRTAMACNIVEL'])
            $row['NRTAMACNIVEL'] = 0;
        $tamanho = 10;
        $completaCom = 'z';
        $row['CDPRODINI'] = $row['CDARVPRODINICIAL'];
        $row['CDPRODFIN'] = $row['CDARVPRODFINAL'];
        $row['CDPRODFIN'] = str_pad($row['CDPRODFIN'], $tamanho, $completaCom, STR_PAD_RIGHT);
        
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);

        $nrorg      = $row['NRORG'];
        $cdfilial   = $row['CDFILIAL'];
        $cdoperador = $row['CDOPERADOR'];
        $cdgrupserv = $row ['LISTAGRUPSERV'];
        if ($row['LISTASERV'] == 'REQUEST') {
            $row['LISTASERV'] = $this->servicoPorGrupo->retornaServicosPorGrupo($nrorg, $cdfilial, $cdoperador, $cdgrupserv);
        }
        $listaParaProcedure = $row['LISTASERV'];
        //Garante que a lista de serviços não seja muito longa na URL
        $row['LISTASERV'] = $this->listas->criarListaValores($row['LISTASERV'], 1000);
        
        if($row['NIVEL'] == 0) {
            $row['NIVEL'] = 'N';
        } else {
            $row['NIVEL'] = 'S';
        }

        if($row["ORDENA"] === "1") {
            $row["NRTAMCODIGO"] = 0;
        } else {
            //numero de caracteres = tamanho total da máscara - os pontos separadores
            $row["NRTAMCODIGO"] = strlen($row["PROD_MASK"]) - substr_count($row["PROD_MASK"], ".");
        }
        
        if(($row['REPORT_NAME'] == 'CUS00800') || ($row['REPORT_NAME'] == 'CUS00801')) {
            $nrConsPlan = $this->novoCodigo->getCodeByTableName('CONSPLAN'.$cdfilial, $nrorg);
    
            $this->procedureConsumoPlanejado->addParam(new Param('P_FILIAL',       Param::PARAM_INPUT, $row['CDFILIAL'],  Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_SERVICOS',     Param::PARAM_INPUT, $listaParaProcedure, Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_DTINICIAL',    Param::PARAM_INPUT, $row['DTINICIAL'], Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_DTFINAL',      Param::PARAM_INPUT, $row['DTFINAL'],   Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_IDARQUIVO',    Param::PARAM_INPUT, "T",               Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_IDPRODUTOS',   Param::PARAM_INPUT, "CFP",             Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_IDSEPPRATO',   Param::PARAM_INPUT, "N",               Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_PEACRESCIMO',  Param::PARAM_INPUT, 0,                 Param::PARAM_TYPE_INT));
            $this->procedureConsumoPlanejado->addParam(new Param('P_IDARREDOND',   Param::PARAM_INPUT, "N",               Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_NRCONSPLAN',   Param::PARAM_INPUT, $nrConsPlan,       Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_CDPRODUTOINI', Param::PARAM_INPUT, $row['CDPRODINI'], Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_CDPRODUTOFIN', Param::PARAM_INPUT, $row['CDPRODFIN'],  Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT, $row['CDOPERADOR'],    Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_STDTINICIAL',  Param::PARAM_INPUT, "_".$dataInicial->format('Ymd')."_", Param::PARAM_TYPE_STR));
            $this->procedureConsumoPlanejado->addParam(new Param('P_STDTFINAL',    Param::PARAM_INPUT, "_".$dataFinal->format('Ymd')."_",   Param::PARAM_TYPE_STR));
    
            $resultado = $this->procedureConsumoPlanejado->execute();
            
            $row['NRCONSPLAN'] = $nrConsPlan;
        }
        $row['DTPERIINIC'] = $row['DTINICIAL'];
        $row['DTPERIFINA'] = $row['DTFINAL'];
    }
}